// CallButton.cpp : implementation file
//

#include "stdafx.h"
#include "Lift.h"
#include "CallButton.h"
#include "LiftWnd.h"
#include "LiftDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCallButton

CCallButton::CCallButton()
{
    IsUp=true;
    m_SelPen.CreatePen(PS_SOLID,3,RGB(0,0,200));
    m_Pen.CreatePen(PS_SOLID,3,RGB(0,0,0));
    m_OnBrush.CreateSolidBrush(RGB(255,0,0));
    m_OffBrush.CreateSolidBrush(RGB(255,255,255));
    m_IsMouseOver=false;
}

CCallButton::~CCallButton()
{
}

BEGIN_MESSAGE_MAP(CCallButton, CButton)
	//{{AFX_MSG_MAP(CCallButton)
	ON_CONTROL_REFLECT(BN_CLICKED, OnClicked)
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCallButton message handlers

BOOL CCallButton::Create(DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, int* check, int floor, BOOL IsUp)
{
    this->IsUp=IsUp;
    *check = 0;
    m_check=check;
    m_floor=floor;
	return CWnd::Create(_T("BUTTON"), "", dwStyle, rect, pParentWnd, nID);
}

void CCallButton::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
    CDC dc;
    dc.Attach(lpDrawItemStruct->hDC);

    if (m_IsMouseOver) dc.SelectObject(m_SelPen); else dc.SelectObject(m_Pen);
    LOGPEN lpen;
    dc.GetCurrentPen()->GetLogPen(&lpen);
    COLORREF cref=lpen.lopnColor;
    if (*m_check!=0) dc.SelectObject(m_OnBrush); else dc.SelectObject(m_OffBrush);
    ::InflateRect(&lpDrawItemStruct->rcItem,-1,-1);
    if (IsUp)
    {
        dc.MoveTo(lpDrawItemStruct->rcItem.left,lpDrawItemStruct->rcItem.bottom-1);
        dc.LineTo((lpDrawItemStruct->rcItem.left+lpDrawItemStruct->rcItem.right-1)/2,lpDrawItemStruct->rcItem.top);
        dc.LineTo(lpDrawItemStruct->rcItem.right-1,lpDrawItemStruct->rcItem.bottom-1);
        dc.LineTo(lpDrawItemStruct->rcItem.left,lpDrawItemStruct->rcItem.bottom-1);
        dc.FloodFill((lpDrawItemStruct->rcItem.left+lpDrawItemStruct->rcItem.right-1)/2,(lpDrawItemStruct->rcItem.top+lpDrawItemStruct->rcItem.bottom-1)/2,cref);
        dc.SelectObject(((CLiftWnd*)this->GetOwner())->m_BkBrush);
        dc.FloodFill(lpDrawItemStruct->rcItem.left,lpDrawItemStruct->rcItem.top,cref);
        dc.FloodFill(lpDrawItemStruct->rcItem.right-1,lpDrawItemStruct->rcItem.top,cref);
    } else {
        dc.MoveTo(lpDrawItemStruct->rcItem.left,lpDrawItemStruct->rcItem.top);
        dc.LineTo((lpDrawItemStruct->rcItem.left+lpDrawItemStruct->rcItem.right-1)/2,lpDrawItemStruct->rcItem.bottom-1);
        dc.LineTo(lpDrawItemStruct->rcItem.right-1,lpDrawItemStruct->rcItem.top);
        dc.LineTo(lpDrawItemStruct->rcItem.left,lpDrawItemStruct->rcItem.top);
        dc.FloodFill((lpDrawItemStruct->rcItem.left+lpDrawItemStruct->rcItem.right-1)/2,(lpDrawItemStruct->rcItem.top+lpDrawItemStruct->rcItem.bottom-1)/2,cref);
        dc.SelectObject(((CLiftWnd*)this->GetOwner())->m_BkBrush);
        dc.FloodFill(lpDrawItemStruct->rcItem.left,lpDrawItemStruct->rcItem.bottom-1,cref);
        dc.FloodFill(lpDrawItemStruct->rcItem.right-1,lpDrawItemStruct->rcItem.bottom-1,cref);
    }
}

void CCallButton::OnClicked() 
{
    if (*m_check==0)
    {
        CString s;
        s.Format(" **     %s  %d ",IsUp?"":"",m_floor);
		((CLiftDlg*)((CLiftApp*)AfxGetApp())->m_pMainWnd)->WriteLog(s);
		((CLiftDlg*)((CLiftApp*)AfxGetApp())->m_pMainWnd)->CallWas();
		(*m_check)++;
    }
    this->Invalidate(false);
}

void CCallButton::OnMouseMove(UINT nFlags, CPoint point) 
{
    for (int i=0; i<=3; i++)
    {
        ((CLiftWnd*)(this->GetOwner()))->m_CallUp[i].m_IsMouseOver=false;
        ((CLiftWnd*)(this->GetOwner()))->m_CallDown[i].m_IsMouseOver=false;
    }
	this->m_IsMouseOver=true;
    ((CLiftWnd*)(this->GetOwner()))->InvalidateCtrls();
	
	CButton::OnMouseMove(nFlags, point);
}
