// Human.cpp : implementation file
//

#include "stdafx.h"
#include "lift.h"
#include "Human.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHuman

CHuman::CHuman()
{
    m_Brush.CreateSolidBrush(RGB(0,0,255));
    m_Pen.CreatePen(PS_SOLID,1,RGB(0,0,255));

    m_Name="Human";
    m_CurFloor=2;
    m_TgtFloor=4;
    m_WaitFor=600;
    m_PutIntoAt=0;
}

CHuman::~CHuman()
{
}

BEGIN_MESSAGE_MAP(CHuman, CWnd)
	//{{AFX_MSG_MAP(CHuman)
	ON_WM_PAINT()
	ON_WM_RBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHuman message handlers

void CHuman::OnPaint() 
{
	CPaintDC dc(this);

    RECT rect;
    this->GetClientRect(&rect);
    dc.SelectObject(m_Pen);
    dc.SelectObject(m_Brush);

    POINT pts[3];
    pts[0].x=rect.left;
    pts[0].y=rect.bottom;
    pts[1].x=rect.right;
    pts[1].y=rect.bottom;
    pts[2].x=(rect.left+rect.right)/2;
    pts[2].y=rect.top+(rect.right-rect.left)/2;
    dc.Polygon(pts,3);

    rect.top-=3;
    rect.bottom=rect.right-3;
    ::InflateRect(&rect,-4,-4);
    dc.Ellipse(&rect);
}

BOOL CHuman::Create(DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID)
{
	return CWnd::Create(NULL, "", dwStyle, rect, pParentWnd, nID);
}

void CHuman::OnRButtonUp(UINT nFlags, CPoint point) 
{
    CHumanDlg hdlg;
    UpdateDialogFields(hdlg);

    hdlg.DoModal();
	
	CWnd::OnRButtonUp(nFlags, point);
}

void CHuman::UpdateDialogFields(CHumanDlg& hdlg)
{
    hdlg.m_Name=this->m_Name;
    hdlg.m_CurFloor=this->m_CurFloor;
    hdlg.m_TgtFloor=this->m_TgtFloor;
    hdlg.m_WaitFor=this->m_WaitFor;
    hdlg.m_PutIntoAt=this->m_PutIntoAt;
}

void CHuman::UpdateHumanFields(CHumanDlg& hdlg)
{
    this->m_Name=hdlg.m_Name;
    this->m_CurFloor=hdlg.m_CurFloor;
    this->m_TgtFloor=hdlg.m_TgtFloor;
    this->m_WaitFor=hdlg.m_WaitFor;
    this->m_PutIntoAt=hdlg.m_PutIntoAt;
}
