#include "stdafx.h"
#include "WinBase.h"
#include "Lift.h"
#include "LiftDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const double CLiftDlg::m_dProp=0.01;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLiftDlg dialog

CLiftDlg::CLiftDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLiftDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLiftDlg)
	m_MenInLift = 0;
	m_MenOnTheFloors = 0;
	m_MenWaiting = 0;
	m_Time = 1;
	m_Pass = 1;
	m_Auto = 0.1;
	m_CFloor0 = FALSE;
	m_CFloor1 = FALSE;
	m_CFloor2 = FALSE;
	m_CFloor3 = FALSE;
	m_CFloor4 = FALSE;
	m_DoLog = TRUE;
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    m_Fnt.CreateFont(15,0,0,0,FW_NORMAL,FALSE,FALSE,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
        DEFAULT_QUALITY,DEFAULT_PITCH|FF_SWISS,"Courier");
    m_LiftWnd = new CLiftWnd;
	m_bDoLive=false;
	srand((unsigned)time(NULL));
}

CLiftDlg::~CLiftDlg()
{

    delete m_LiftWnd;
}

void CLiftDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLiftDlg)
	DDX_Text(pDX, IDC_SHOWMENINLIFT, m_MenInLift);
	DDX_Text(pDX, IDC_SHOWMENONTHEFLOORS, m_MenOnTheFloors);
	DDX_Text(pDX, IDC_SHOWMENWAITING, m_MenWaiting);
	DDX_Text(pDX, IDC_SHOWTIME, m_Time);
	DDX_Text(pDX, IDC_EDIT_PASS, m_Pass);
	DDX_Text(pDX, IDC_EDIT_AUTO, m_Auto);
	DDX_Check(pDX, IDC_CFLOOR0, m_CFloor0);
	DDX_Check(pDX, IDC_CFLOOR1, m_CFloor1);
	DDX_Check(pDX, IDC_CFLOOR2, m_CFloor2);
	DDX_Check(pDX, IDC_CFLOOR3, m_CFloor3);
	DDX_Check(pDX, IDC_CFLOOR4, m_CFloor4);
	DDX_Check(pDX, IDC_DOLOG, m_DoLog);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CLiftDlg, CDialog)
	//{{AFX_MSG_MAP(CLiftDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_HELP_ABOUT, OnHelpAbout)
	ON_COMMAND(ID_MODEL_EXIT, OnModelExit)
	ON_WM_MOUSEMOVE()
	ON_COMMAND(ID_MODEL_RESET, OnModelReset)
	ON_COMMAND(ID_VIEW_LOGWINDOW, OnViewLogwindow)
	ON_BN_CLICKED(ID_VIEW_LOGWINDOW1, OnViewLogwindow1)
	ON_COMMAND(ID_VIEW_ADDHUMANWINDOW, OnViewAddhumanwindow)
	ON_BN_CLICKED(ID_VIEW_ADDHUMANWINDOW1, OnViewAddhumanwindow1)
	ON_BN_CLICKED(IDC_STEP, OnStep)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_PASS, OnDeltaposSpinPass)
	ON_EN_CHANGE(IDC_EDIT_PASS, OnChangeEditPass)
	ON_EN_CHANGE(IDC_EDIT_AUTO, OnChangeEditAuto)
	ON_BN_CLICKED(IDC_PASS, OnPass)
	ON_BN_CLICKED(IDC_AUTO, OnAuto)
	ON_WM_TIMER()
	ON_COMMAND(ID_VIEW_TIMEOUTSTUNINGWINDOW, OnViewTimeoutstuningwindow)
	ON_BN_CLICKED(IDC_CFLOOR0, OnCfloor0)
	ON_BN_CLICKED(IDC_CFLOOR1, OnCfloor1)
	ON_BN_CLICKED(IDC_CFLOOR2, OnCfloor2)
	ON_BN_CLICKED(IDC_CFLOOR3, OnCfloor3)
	ON_BN_CLICKED(IDC_CFLOOR4, OnCfloor4)
	ON_BN_CLICKED(IDC_DOLOG, OnDolog)
	ON_BN_CLICKED(ID_MODEL_RESET, OnModelReset)
	ON_BN_CLICKED(IDC_LIVE, OnLive)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLiftDlg message handlers

BOOL CLiftDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);

    ((CLiftApp*)AfxGetApp())->m_LogDlg.Create(IDD_LOG,this);
    ((CLiftApp*)AfxGetApp())->m_LogDlg.m_Log.SetFont(&m_Fnt);

    RECT rect;
    GetDlgItem(IDC_SPACE)->GetClientRect(&rect);
    m_LiftWnd->Create(WS_CHILD|WS_VISIBLE,rect,GetDlgItem(IDC_SPACE),60000);

	return TRUE;
}

void CLiftDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CLiftDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this);
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		dc.DrawIcon(x, y, m_hIcon);
	}
	else CDialog::OnPaint();
}

HCURSOR CLiftDlg::OnQueryDragIcon()
{
    return (HCURSOR) m_hIcon;
}

void CLiftDlg::OnHelpAbout() 
{
    CAboutDlg dlgAbout;
    dlgAbout.DoModal();
}

void CLiftDlg::OnModelExit() 
{
    EndDialog(IDOK);
}

void CLiftDlg::OnModelReset() 
{
    m_LiftWnd->ReInit();

	m_CFloor0=(m_LiftWnd->aA0.calls.car[0]!=0);
    m_CFloor1=(m_LiftWnd->aA0.calls.car[1]!=0);
    m_CFloor2=(m_LiftWnd->aA0.calls.car[2]!=0);
    m_CFloor3=(m_LiftWnd->aA0.calls.car[3]!=0);
    m_CFloor4=(m_LiftWnd->aA0.calls.car[4]!=0);

	UpdateData(FALSE);
}

void CLiftDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
    for (int i=0; i<=3; i++)
    {
        this->m_LiftWnd->m_CallUp[i].m_IsMouseOver=false;
        this->m_LiftWnd->m_CallDown[i].m_IsMouseOver=false;
    }
    this->m_LiftWnd->InvalidateCtrls();

	CDialog::OnMouseMove(nFlags, point);
}

void CLiftDlg::OnViewLogwindow() 
{
    if (((CLiftApp*)AfxGetApp())->m_LogDlg.IsWindowVisible())
    {
        ((CLiftApp*)AfxGetApp())->m_LogDlg.ShowWindow(SW_HIDE); 
        GetMenu()->CheckMenuItem(ID_VIEW_LOGWINDOW,MF_UNCHECKED);
        CheckDlgButton(ID_VIEW_LOGWINDOW1,MF_UNCHECKED);
    } else {
        ((CLiftApp*)AfxGetApp())->m_LogDlg.ShowWindow(SW_SHOW);
        GetMenu()->CheckMenuItem(ID_VIEW_LOGWINDOW,MF_CHECKED);
        CheckDlgButton(ID_VIEW_LOGWINDOW1,MF_CHECKED);
        ((CLiftApp*)AfxGetApp())->m_LogDlg.m_Log.SetWindowText(((CLiftApp*)AfxGetApp())->m_LogDlg.m_sLog);
    }
}

void CLiftDlg::OnViewLogwindow1() 
{
    OnViewLogwindow();
}

void CLiftDlg::OnViewAddhumanwindow() 
{
    CHuman* pHum=new CHuman;
    CHumanDlg hdlg;
    pHum->UpdateDialogFields(hdlg);
    CString st;
    st.Format("Human#%u",m_HumanIndex);
    hdlg.m_Name=st;
    m_HumanIndex++;
    hdlg.m_PutIntoAt=m_Time;
    if (hdlg.DoModal()==IDOK)
    {
        pHum->UpdateHumanFields(hdlg);
        if (pHum->GetWaitFor()==0)
        {
            AfxMessageBox("Oh, he is in a hurry!",MB_APPLMODAL|MB_ICONEXCLAMATION|MB_OK,0);
            delete pHum;
            return;
        }
        if (pHum->GetCurFloor()==pHum->GetTgtFloor())
        {
            AfxMessageBox("This humans wishes are already satisfied!",MB_APPLMODAL|MB_ICONEXCLAMATION|MB_OK,0);
            delete pHum;
            return;
        }
        if (hdlg.m_PutIntoAt<m_Time)
        {
            AfxMessageBox("Moment, when this person was eager to enter the lift went by!",MB_APPLMODAL|MB_ICONSTOP|MB_OK,0);
            delete pHum;
            return;
        }
        if (pHum->GetPutIntoAt()!=m_Time)
        {
            ((CLiftApp*)AfxGetApp())->waits.AddTail(pHum);
            m_MenWaiting++;
        } else PutHuman(pHum);
		CallWas();
        this->m_LiftWnd->InvalidateCtrls();
        UpdateData(FALSE);
        return;
    }
    delete pHum;
}

void CLiftDlg::OnViewAddhumanwindow1() 
{
	OnViewAddhumanwindow();
}

void CLiftDlg::ClearList(humanlist& lst)
{
    POSITION pos=lst.GetHeadPosition();
    for (int i=0;i<lst.GetCount();i++) delete lst.GetNext(pos);
    lst.RemoveAll();
}

void CLiftDlg::ClearLists()
{
    for (int i=0;i<5;i++) ClearList(((CLiftApp*)AfxGetApp())->people[i]);
    ClearList(((CLiftApp*)AfxGetApp())->waits);
    ClearList(((CLiftApp*)AfxGetApp())->inlift);
}

void CLiftDlg::WriteLog(CString s)
{
	if (!m_DoLog) return;
    ((CLiftApp*)AfxGetApp())->m_LogDlg.m_sLog+=s+"\r\n";
}

void CLiftDlg::LogMoment(UINT time,BOOL begin)
{
    CString s;
    if (begin==TRUE) s.Format(">>>>>  %u.  >>>>>",time);
        else s.Format("<<<<<  %u.  <<<<<",time);
    WriteLog(s);
}

void CLiftDlg::OnDeltaposSpinPass(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	if ((m_Pass<2&&pNMUpDown->iDelta>0)||(m_Pass>4294967294&&pNMUpDown->iDelta<0)) return;
    m_Pass-=pNMUpDown->iDelta;
    UpdateData(FALSE);
	*pResult = 0;
}

void CLiftDlg::OnChangeEditPass() 
{
    UpdateData(TRUE);
}

void CLiftDlg::OnChangeEditAuto() 
{
    UpdateData(TRUE);
}

void CLiftDlg::OnViewTimeoutstuningwindow() 
{
    if (m_Time!=1)
	{
        AfxMessageBox("You can tune timeouts only on the first step!\nIf you want - press \"Reset\" now.",MB_APPLMODAL|MB_ICONSTOP|MB_OK,0);
		return;
	}
	((CLiftApp*)AfxGetApp())->m_TODlg.DoModal();
}

void CLiftDlg::DecreaseWaitFor(humanlist& lst)
{
    POSITION pos=lst.GetHeadPosition();
    for (int i=0;i<lst.GetCount();i++)
    {
        CHuman* pHum=lst.GetNext(pos);
        pHum->SetWaitFor(pHum->GetWaitFor()-1);
        if (pHum->GetWaitFor()==0) {
            CString s;
            s.Format(" **  %s   ",pHum->GetName());
            WriteLog(s);
            delete pHum;
            lst.RemoveAt(lst.FindIndex(i));
            i--;
            m_MenOnTheFloors--;
        }
    }
}

void CLiftDlg::CheckPutIntoAt(humanlist& lst)
{
    POSITION pos=lst.GetHeadPosition();
    for (int i=0;i<lst.GetCount();i++)
    {
        CHuman* pHum=lst.GetNext(pos);
        if (pHum->GetPutIntoAt()==m_Time) {
            PutHuman(pHum);
            lst.RemoveAt(lst.FindIndex(i));
            i--;
            m_MenWaiting--;
        }
    }
}

void CLiftDlg::PeopleInOut()
{
	if (m_LiftWnd->aA0.aA2.mover[m_LiftWnd->aA0.floor]!=1.0) return;

	if (((CLiftApp*)AfxGetApp())->m_MenMoving>0) ((CLiftApp*)AfxGetApp())->m_MenMoving--;
	if (((CLiftApp*)AfxGetApp())->m_MenMoving>0) return;

	humanlist* lst=&((CLiftApp*)AfxGetApp())->inlift;

    POSITION pos=lst->GetHeadPosition();
    for (int i=0;i<lst->GetCount();i++)
    {
        CHuman* pHum=lst->GetNext(pos);
        if (pHum->GetTgtFloor()==m_LiftWnd->aA0.floor) {
			CString s;
			s.Format(" **  %s    %d",pHum->GetName(),pHum->GetTgtFloor());
			WriteLog(s);
			delete pHum;
            lst->RemoveAt(lst->FindIndex(i));
            i--;
            m_MenInLift--;
			((CLiftApp*)AfxGetApp())->m_MenMoving=((CLiftApp*)AfxGetApp())->m_TODlg.m_THuman;
			return;
        }
    }

	lst=&((CLiftApp*)AfxGetApp())->people[m_LiftWnd->aA0.floor];

    pos=lst->GetHeadPosition();
    for (i=0;i<lst->GetCount();i++)
    {
        CHuman* pHum=lst->GetNext(pos);
        if ((pHum->GetTgtFloor()>m_LiftWnd->aA0.floor && m_LiftWnd->aA0.state==m_LiftWnd->aA0.GOINGUP) ||
			(pHum->GetTgtFloor()<m_LiftWnd->aA0.floor && m_LiftWnd->aA0.state==m_LiftWnd->aA0.GOINGDOWN) ||
			(m_LiftWnd->aA0.state==m_LiftWnd->aA0.NEUTRAL))
		{
			if (m_LiftWnd->aA0.state==m_LiftWnd->aA0.NEUTRAL) m_LiftWnd->aA0.state=(pHum->GetTgtFloor()>pHum->GetCurFloor()?m_LiftWnd->aA0.GOINGUP:m_LiftWnd->aA0.GOINGDOWN);
			pHum->ShowWindow(SW_HIDE);
			((CLiftApp*)AfxGetApp())->inlift.AddTail(pHum);
			m_LiftWnd->aA0.calls.car[pHum->GetTgtFloor()]++;
			CString s;
			s.Format(" **  %s      %d",pHum->GetName(),pHum->GetCurFloor());
			WriteLog(s);
            lst->RemoveAt(lst->FindIndex(i));
            i--;
            m_MenOnTheFloors--;
            m_MenInLift++;
			((CLiftApp*)AfxGetApp())->m_MenMoving=((CLiftApp*)AfxGetApp())->m_TODlg.m_THuman;
			return;
        }
    }
}

void CLiftDlg::PutHuman(CHuman* pHum)
{
    ((CLiftApp*)AfxGetApp())->people[pHum->GetCurFloor()].AddTail(pHum);
    pHum->Create(WS_CHILD,CRect(0,0,0,0),this->m_LiftWnd,0);
    m_MenOnTheFloors++;
    if (pHum->GetCurFloor()<pHum->GetTgtFloor()) this->m_LiftWnd->aA0.calls.up[pHum->GetCurFloor()]++;
        else this->m_LiftWnd->aA0.calls.down[pHum->GetCurFloor()]++;
    CString s;
    s.Format(" **  %s   %d     %d (  %u  )",pHum->GetName(),pHum->GetCurFloor(),pHum->GetTgtFloor(),pHum->GetWaitFor());
    WriteLog(s);
}

void CLiftDlg::OnStep() 
{
    LogMoment(m_Time,FALSE);
    m_Time++;
    LogMoment(m_Time,TRUE);

    for (int i=0;i<5;i++) DecreaseWaitFor(((CLiftApp*)AfxGetApp())->people[i]);
    CheckPutIntoAt(((CLiftApp*)AfxGetApp())->waits);

	if (m_LiftWnd->aA0.timer>0) m_LiftWnd->aA0.timer--;
	if (m_LiftWnd->aA0.inactivitytimer>0 && m_LiftWnd->aA0.state==m_LiftWnd->aA0.NEUTRAL) m_LiftWnd->aA0.inactivitytimer--;
	if (m_LiftWnd->aA0.aA2.timer>0) m_LiftWnd->aA0.aA2.timer--;

    if (m_bDoLive && Random()<m_dProp)
	{
		CHuman* pHum=new CHuman;
		CString st;
		st.Format("Human#%u",m_HumanIndex);
		pHum->SetName(st);
		pHum->SetPutIntoAt(m_Time);
		pHum->SetWaitFor(600);
		pHum->SetCurFloor((uchar)(Random()*5));
		uchar c;
		do c=(uchar)(Random()*5); while (c==pHum->GetCurFloor());
		pHum->SetTgtFloor(c);
		m_HumanIndex++;
		PutHuman(pHum);
		CallWas();
        this->m_LiftWnd->InvalidateCtrls();
        UpdateData(FALSE);
	}

	m_LiftWnd->aA0.Main(m_LiftWnd->aA0.e1);

	m_LiftWnd->aA0.calls.newcalls=false;

	PeopleInOut();
	m_LiftWnd->PaintDyn();
    UpdateLog();

	m_CFloor0=(m_LiftWnd->aA0.calls.car[0]!=0);
    m_CFloor1=(m_LiftWnd->aA0.calls.car[1]!=0);
    m_CFloor2=(m_LiftWnd->aA0.calls.car[2]!=0);
    m_CFloor3=(m_LiftWnd->aA0.calls.car[3]!=0);
    m_CFloor4=(m_LiftWnd->aA0.calls.car[4]!=0);

    UpdateData(FALSE);
}

void CLiftDlg::OnPass() 
{
	for (UINT i=0;i<m_Pass;i++) OnStep();
}

void CLiftDlg::OnAuto() 
{
    if (((CButton*)GetDlgItem(IDC_AUTO))->GetCheck())
    {
        EnableControl(false);
        this->SetTimer(1,(long)(1000.0*m_Auto),NULL);
    } else {
        EnableControl(true);
        this->KillTimer(1);
    }
}

void CLiftDlg::OnTimer(UINT nIDEvent) 
{
	OnPass();
    CDialog::OnTimer(nIDEvent);
}

void CLiftDlg::CfloorBtn(BOOL& btn, int i)
{
    if (btn==FALSE)
    {
        btn=TRUE;
        if (m_LiftWnd->aA0.calls.car[i]==0) m_LiftWnd->aA0.calls.car[i]++;
        CString s;
        s.Format(" **         %d ",i);
        WriteLog(s);
        UpdateData(FALSE);
		CallWas();
    }
}

void CLiftDlg::OnCfloor0() 
{
    CfloorBtn(m_CFloor0,0);
}

void CLiftDlg::OnCfloor1() 
{
    CfloorBtn(m_CFloor1,1);
}

void CLiftDlg::OnCfloor2() 
{
    CfloorBtn(m_CFloor2,2);
}

void CLiftDlg::OnCfloor3() 
{
    CfloorBtn(m_CFloor3,3);
}

void CLiftDlg::OnCfloor4() 
{
    CfloorBtn(m_CFloor4,4);
}

void CLiftDlg::UpdateLog() 
{
    if (((CLiftApp*)AfxGetApp())->m_LogDlg.m_Log.IsWindowVisible()) ((CLiftApp*)AfxGetApp())->m_LogDlg.m_Log.SetWindowText(((CLiftApp*)AfxGetApp())->m_LogDlg.m_sLog);
}

void CLiftDlg::EnableControl(bool enab)
{
	((CButton*)GetDlgItem(IDC_PASS))->EnableWindow(enab);
	((CButton*)GetDlgItem(IDC_STEP))->EnableWindow(enab);
	((CButton*)GetDlgItem(ID_MODEL_RESET))->EnableWindow(enab);
	((CButton*)GetDlgItem(ID_VIEW_LOGWINDOW1))->EnableWindow(enab);
	((CButton*)GetDlgItem(ID_VIEW_ADDHUMANWINDOW1))->EnableWindow(enab);

	((CEdit*)GetDlgItem(IDC_EDIT_AUTO))->EnableWindow(enab);
	((CEdit*)GetDlgItem(IDC_EDIT_PASS))->EnableWindow(enab);
	((CSpinButtonCtrl*)GetDlgItem(IDC_SPIN_PASS))->EnableWindow(enab);

	CMenu* menu=GetMenu();
	menu->EnableMenuItem(ID_MODEL_RESET,enab?MF_ENABLED:MF_GRAYED);
	menu->EnableMenuItem(ID_MODEL_EXIT,enab?MF_ENABLED:MF_GRAYED);
	menu->EnableMenuItem(ID_VIEW_LOGWINDOW,enab?MF_ENABLED:MF_GRAYED);
	menu->EnableMenuItem(ID_VIEW_TIMEOUTSTUNINGWINDOW,enab?MF_ENABLED:MF_GRAYED);
	menu->EnableMenuItem(ID_VIEW_ADDHUMANWINDOW,enab?MF_ENABLED:MF_GRAYED);
	menu->EnableMenuItem(ID_HELP_ABOUT,enab?MF_ENABLED:MF_GRAYED);
}

void CLiftDlg::CallWas()
{
	m_LiftWnd->aA0.inactivitytimer=-1;
	m_LiftWnd->aA0.calls.newcalls=true;
}

void CLiftDlg::OnDolog() 
{
	UpdateData(TRUE);
	m_LiftWnd->aA0.DoLog=m_DoLog?true:false;
	m_LiftWnd->aA0.aA1.DoLog=m_DoLog?true:false;
	m_LiftWnd->aA0.aA2.DoLog=m_DoLog?true:false;
}

void CLiftDlg::OnLive() 
{
	m_bDoLive=(((CButton*)GetDlgItem(IDC_LIVE))->GetCheck()==0?false:true);
}

double CLiftDlg::Random()
{
	return (double)rand()/(double)RAND_MAX;
}
