#if !defined(AFX_LIFTDLG_H__83AB3F83_DA4C_4F22_B7BA_F18199DD5E11__INCLUDED_)
#define AFX_LIFTDLG_H__83AB3F83_DA4C_4F22_B7BA_F18199DD5E11__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "LiftWnd.h"

/////////////////////////////////////////////////////////////////////////////
// CLiftDlg dialog

class CLiftDlg : public CDialog
{
// Construction
public:
	CLiftDlg(CWnd* pParent = NULL);	// standard constructor
    UINT m_HumanIndex;

// Dialog Data
	//{{AFX_DATA(CLiftDlg)
	enum { IDD = IDD_LIFT_DIALOG };
	UINT m_MenInLift;
	UINT m_MenOnTheFloors;
	UINT m_MenWaiting;
	UINT m_Time;
	UINT m_Pass;
	double m_Auto;
	BOOL	m_CFloor0;
	BOOL	m_CFloor1;
	BOOL	m_CFloor2;
	BOOL	m_CFloor3;
	BOOL	m_CFloor4;
	BOOL	m_DoLog;
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CLiftDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

private:
    inline void ClearList(humanlist& lst);
    inline void DecreaseWaitFor(humanlist& lst);
    inline void CheckPutIntoAt(humanlist& lst);
    inline void PutHuman(CHuman* pHum);
    inline void CfloorBtn(BOOL& btn, int i);
    inline void UpdateLog();

public:
	inline static double Random();
	void CallWas();
	virtual ~CLiftDlg();
    void ClearLists();
    void WriteLog(CString s);
    void LogMoment(UINT time,BOOL begin=TRUE);
	void EnableControl(bool enab=true);
	void PeopleInOut();

// Implementation
protected:
	HICON m_hIcon;
    CLiftWnd* m_LiftWnd;
    CFont m_Fnt;
	bool m_bDoLive;
	const static double m_dProp;

	//{{AFX_MSG(CLiftDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnHelpAbout();
	afx_msg void OnModelExit();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnModelReset();
	afx_msg void OnViewLogwindow();
	afx_msg void OnViewLogwindow1();
	afx_msg void OnViewAddhumanwindow();
	afx_msg void OnViewAddhumanwindow1();
	afx_msg void OnStep();
	afx_msg void OnDeltaposSpinPass(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnChangeEditPass();
	afx_msg void OnChangeEditAuto();
	afx_msg void OnPass();
	afx_msg void OnAuto();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnViewTimeoutstuningwindow();
	afx_msg void OnCfloor0();
	afx_msg void OnCfloor1();
	afx_msg void OnCfloor2();
	afx_msg void OnCfloor3();
	afx_msg void OnCfloor4();
	afx_msg void OnDolog();
	afx_msg void OnLive();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}

#endif // !defined(AFX_LIFTDLG_H__83AB3F83_DA4C_4F22_B7BA_F18199DD5E11__INCLUDED_)
