#include "stdafx.h"
#include "Lift.h"
#include "LiftWnd.h"
#include "LiftDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLiftWnd

CLiftWnd::CLiftWnd()
{
    m_BkBrush.CreateSolidBrush(RGB(255,255,207));
    m_FlBrush.CreateSolidBrush(RGB(184,0,0));
    m_CarBrush.CreateSolidBrush(RGB(0,0,0));
    m_CarBkBrush.CreateSolidBrush(RGB(128,128,0));
    m_RopBrush.CreateSolidBrush(RGB(0,0,255));
    m_OnBrush.CreateSolidBrush(RGB(0,255,255));
    m_OffBrush.CreateSolidBrush(RGB(165,165,0));
    m_Font.CreateFont(16,0,0,0,FW_BOLD,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH|FF_SWISS,"Times New Roman");
    m_Font2.CreateFont(14,0,0,0,FW_NORMAL,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH|FF_SWISS,"Arial");
    m_CarPen.CreatePen(PS_SOLID,1,RGB(0,0,0));
}

CLiftWnd::~CLiftWnd()
{
}

BEGIN_MESSAGE_MAP(CLiftWnd, CWnd)
	//{{AFX_MSG_MAP(CLiftWnd)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLiftWnd message handlers

BOOL CLiftWnd::Create(DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID)
{
	BOOL result=CWnd::Create(_T("STATIC"), "", dwStyle, rect, pParentWnd, nID);

    int height=rect.bottom+1;
    int width=rect.right+1;

    RECT brect;
    brect.left=(long)(width*0.25);
    brect.right=brect.left+(long)(width*0.07);

    for (int i=0; i<=3; i++)
    {
        brect.top=height-(long)(((4-i)/5.0-1.0/25.0)*height);
        brect.bottom=brect.top+(long)(height*0.055);
        result &= m_CallUp[i].Create(WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON|BS_OWNERDRAW,brect,this,60001+i,&(aA0.calls.up[3-i]),3-i,true);
    }

    for (i=0; i<=3; i++)
    {
        brect.top=height-(long)(((4-i)/5.0+95.0/1000.0)*height)-2;
        brect.bottom=brect.top+(long)(height*0.055);
        result &= m_CallDown[i].Create(WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON|BS_OWNERDRAW,brect,this,60005+i,&(aA0.calls.down[4-i]),4-i,false);
    }

// Initialization of automata service variables
    aA0.DoLog=true;
    aA0.aA1.DoLog=true;
    aA0.aA2.DoLog=true;
    aA0.BaseIndent=1;
    aA0.aA1.BaseIndent=4;
    aA0.aA2.BaseIndent=4;

    ReInit();
 
    return result;
}

void CLiftWnd::OnPaint()
{
	CPaintDC dc(this);
    dc.SelectObject(&m_Font);
    dc.SetBkMode(TRANSPARENT);

    RECT rect;
    GetClientRect(&rect);
    int height=rect.bottom+1;
//    int width=rect.right+1;

    // Background filling
    dc.FillRect(&rect,&m_BkBrush);

    // Floors drawing
    rect.right=(long)(height/15.0);
    for (int i=0; i<6; i++) {
        rect.top=height-(long)((i/5.0-1.0/25.0)*height);
        rect.bottom=height-(long)((i/5.0+1.0/25.0)*height);
        dc.FillRect(&rect,&m_FlBrush);
    }
    rect.right=height-1;
    rect.left=(long)(height/5.0);
    for (i=0; i<6; i++) {
        rect.top=(long)((i/5.0-1.0/25.0)*height);
        rect.bottom=(long)((i/5.0+1.0/25.0)*height);
        dc.FillRect(&rect,&m_FlBrush);
    }

    // Comment floors
    CString captions[5]={"Basement (0)","Ground floor (1)","First floor (2)","Second floor (3)","Third floor (4)"};
    dc.SetTextColor(RGB(0,100,0));
    for (i=0; i<5; i++) 
        dc.TextOut((long)(height/5.0)+(long)(4.0/5.0*height-dc.GetTextExtent(captions[4-i]).cx)/2,(long)((i/5.0+1.0/25.0)*height)+2,captions[4-i]);

    // Draw the system
    DrawIt(dc);
}

void CLiftWnd::DrawIt(CDC& dc)
{
    DrawDoors(dc);
    ClipLift(dc);
    DrawLift(dc);
    InvalidateCtrls();
}

void CLiftWnd::ClipLift(CDC& dc)
{
    if (m_dOldRope==aA0.aA1.rope) return;
    RECT rect;
    GetClientRect(&rect);
    int height=rect.bottom+1;
//    int width=rect.right+1;

	if (aA0.state==aA0.GOINGUP)
	{
		rect.left=(long)(height/15.0)+3;
		rect.right=(long)(height/5.0)-3;
		rect.top=(long)((aA0.aA1.rope/5.0+9.6/50.0)*height);
		rect.bottom=(long)((m_dOldRope/5.0+9.6/50.0)*height);
		dc.FillRect(&rect,&m_BkBrush);
	} else
	if (aA0.state==aA0.GOINGDOWN)
	{
		rect.left=(long)(height/15.0)+3;
		rect.right=(long)(height/5.0)-3;
		rect.top=(long)((m_dOldRope/5.0+1.0/50.0)*height);
		rect.bottom=(long)((aA0.aA1.rope/5.0+1.0/50.0)*height);		
		dc.FillRect(&rect,&m_BkBrush);
	}
}

void CLiftWnd::DrawLift(CDC& dc)
{
    RECT rect;
    GetClientRect(&rect);
    int height=rect.bottom+1;
//    int width=rect.right+1;

    dc.SelectObject(&m_CarPen);
    dc.SelectObject(&m_RopBrush);

    // Drawing a rope
    rect.left=(long)(2.0*height/15.0)-3;
    rect.right=rect.left+5;
    rect.top=-1;
    rect.bottom=(long)((aA0.aA1.rope/5.0+1.0/50.0)*height)+1;
    dc.Rectangle(&rect);

    // Drawing a cabin
    rect.left=(long)(height/15.0)+3;
    rect.right=(long)(height/5.0)-3;
    rect.top=(long)((aA0.aA1.rope/5.0+1.0/50.0)*height);
    rect.bottom=rect.top+(long)((4.3/25.0)*height);
    dc.FillRect(&rect,&m_CarBrush);
    rect.left=(long)(height/15.0)+9;
    rect.right=(long)(height/5.0)-9;
    rect.top=(long)((aA0.aA1.rope/5.0+1.0/25.0)*height)-1;
    rect.bottom=rect.top+(long)((3.0/25.0)*height);
    dc.FillRect(&rect,&m_CarBkBrush);

    // Drawing motion indicators
    long i=(long)((aA0.aA1.rope/5.0+1.0/25.0)*height);
    long j=(long)(2*height/15.0);
    POINT pts[3];
    pts[0].x=j;
    pts[0].y=i+3;
    pts[1].x=j+11;
    pts[1].y=i+17;
    pts[2].x=j-11;
    pts[2].y=i+17;
    if (aA0.state==aA0.GOINGUP) dc.SelectObject(m_OnBrush);
        else dc.SelectObject(m_OffBrush);
    dc.Polygon(pts,3);

    pts[0].x=j;
    pts[0].y=i+35;
    pts[1].x=j+11;
    pts[1].y=i+21;
    pts[2].x=j-11;
    pts[2].y=i+21;
    if (aA0.state==aA0.GOINGDOWN) dc.SelectObject(m_OnBrush);
        else dc.SelectObject(m_OffBrush);
    dc.Polygon(pts,3);

    dc.SelectObject(&m_Font2);
    dc.SetBkMode(TRANSPARENT);
    dc.SetTextColor(RGB(255,255,0));
    CString str;
    str.Format("%d",((CLiftDlg*)(AfxGetApp()->m_pMainWnd))->m_MenInLift);
    dc.TextOut(j-dc.GetTextExtent(str).cx/2,i+37,str);

    m_dOldRope=aA0.aA1.rope;
}

void CLiftWnd::DrawDoors(CDC& dc)
{
    RECT rect;
    GetClientRect(&rect);
    int height=rect.bottom+1;
//    int width=rect.right+1;

    for (int i=0; i<=4; i++) {
        rect.right=(long)(height*(1/5.0+1/40.0));
        rect.left=(long)(height/5.0);

        rect.top=(long)((i/5.0+1.0/25.0)*height);
        long j=(long)(((i+1)/5.0-1.0/25.0)*height);
        rect.bottom=rect.top+(long)((j-rect.top)*(1-aA0.aA2.mover[4-i]));
        dc.FillRect(&rect,&m_CarBrush);

        rect.top=rect.bottom;
        rect.bottom=j;
        if (rect.top<rect.bottom) dc.FillRect(&rect,&m_BkBrush);
    }
}

void CLiftWnd::InvalidateCtrls()
{
    for(int i=0; i<=3; i++) {
        m_CallUp[i].Invalidate(false);
        m_CallDown[i].Invalidate(false);
    }

    for (i=0;i<5;i++) InvalidateHumans(((CLiftApp*)AfxGetApp())->people[i],i);
}

void CLiftWnd::InvalidateHumans(humanlist& lst, int fl)
{
    RECT rect;
    GetClientRect(&rect);
    int height=rect.bottom+1;
    int width=rect.right+1;

    long cx=(long)(height*0.055);
    long cy=(long)(width*0.087);
    long x=(long)(height*0.325);
    long y=height-(long)((fl/5.0+1.0/25.0)*height)-cy-2;

    POSITION pos=lst.GetHeadPosition();
    for (int i=0;i<lst.GetCount();i++)
    {
        CHuman* pHum=lst.GetNext(pos);
        pHum->ShowWindow(SW_SHOW);
        pHum->MoveWindow(x+i*(cx+2),y,cx,cy,TRUE);
    }
}

void CLiftWnd::ReInit()
{
    ((CLiftApp*)AfxGetApp())->m_LogDlg.m_sLog="";
    ((CLiftApp*)AfxGetApp())->m_MenMoving=0;
    CLiftDlg* dlg=(CLiftDlg*)(((CLiftApp*)AfxGetApp())->GetMainWnd());

	aA0.y=0;
	aA0.aA1.y=0;
	aA0.aA2.y=0;

    m_dOldRope=2.0;
    dlg->LogMoment(1,TRUE);
    aA0.Main(aA0.e0);

    dlg->ClearLists();
	dlg->m_MenInLift=0;
	dlg->m_MenOnTheFloors=0;
	dlg->m_MenWaiting=0;
	dlg->m_Time=1;
    dlg->m_HumanIndex=1;
    dlg->UpdateData(FALSE);

    Invalidate(FALSE);
}

void CLiftWnd::PaintDyn()
{
	CDC* pDC=GetDC();
    DrawIt(*pDC);
	ReleaseDC(pDC);
}
